# -*- coding: utf-8 -*-
"""Main Controller"""

from tg import expose, flash, require, url, lurl
from tg import request, redirect, tmpl_context
from tg.i18n import ugettext as _, lazy_ugettext as l_
from tg.exceptions import HTTPFound

from hoyataxa.lib.base import BaseController
from hoyataxa.controllers.error import ErrorController

__all__ = ['RootController']

from hoyataxa.model.taxa import *

initdb()

class RootController(BaseController):

    @expose('hoyataxa.templates.index')
    def index(self):
        "Front page"
        return dict(title="Hoya Taxa!")
    
    @expose(template="hoyataxa.templates.taxa")
    def taxa(self,taxid):
        """"Return the Taxonomy object."""
        t = Taxonomy.byTaxid(int(taxid))
        lineage = []
        t1 = t
        while t1.taxid != 1:
            if t1.rank != 'no rank':
                lineage.append(t1)
            t1 = t1.parent
        lineage.reverse()
        return dict(title=t.scientific_name,
                    taxa=t, lineage=lineage)
